--- lambdabot-4.2.2.1-orig/lambdabot.cabal	2009-01-18 16:01:17.000000000 +1100
+++ lambdabot-4.2.2.1/lambdabot.cabal	2011-01-04 15:26:08.395572470 +1100
@@ -26,8 +26,11 @@
                     State/imports.h,
                     online.rc, online2.rc
 
+flag eval
+    description: Use mueval to evaluate pure Haskell expressions at runtime
+
 Library
-    build-depends: base, mtl, bytestring, unix
+    build-depends: base, mtl, bytestring, unix, filepath
     exposed-modules: Config, IRCBase, File,
                      LBState, LMain, Lambdabot, Message,
                      NickEq, Plugin, Plugin.Activity, Plugin.BF,
@@ -52,13 +55,18 @@
 
 -- Lambdabot main
 Executable          lambdabot
-    Build-depends:       containers, directory, pretty, parsec, old-time, random, array, network,
+    Build-depends:       base >= 4 && < 5,
+                         containers, directory, pretty, parsec, old-time, random, array, network,
                          regex-compat, readline, binary>0.2, haskell-src,
                          -- TODO: update Plugin.Eval for 0.4 and up
-                         haskell-src-exts>=0.3.6 && < 0.4,
-                         oeis, lambdabot-utils, show>=0.3, utf8-string, template-haskell,
-                         -- runtime dependencies
-                         brainfuck, unlambda, template-haskell
+                         haskell-src-exts>=0.3.6 && < 2.0,
+                         oeis, lambdabot-utils, show>=0.3, utf8-string, template-haskell, filepath, tagsoup, HTTP,
+                         unix, base, mtl, bytestring, syb,
+                         -- runtime dependencies - for eval etc.
+                         brainfuck, unlambda, template-haskell, numbers, logict, IOSpec, vector-space, MonadRandom,
+                         data-memocombinators, arrows
+    if flag(eval)
+        Build-depends: mueval>=0.8
     Main-is:             Main.hs
     -- For a faster build, use -Onot
     ghc-options:         -funbox-strict-fields -fno-warn-incomplete-patterns
--- lambdabot-4.2.2.1-orig/Lambdabot.hs	2009-01-18 16:01:14.000000000 +1100
+++ lambdabot-4.2.2.1/Lambdabot.hs	2010-12-10 13:03:54.287148735 +1100
@@ -69,7 +69,7 @@
 
 import Control.Concurrent (myThreadId, newEmptyMVar, newMVar, readMVar, putMVar,
                            takeMVar, threadDelay, MVar, ThreadId)
-import Control.Exception
+import Control.OldException
 import Control.Monad.Error (MonadError (..))
 import Control.Monad.Reader
 import Control.Monad.State
--- lambdabot-4.2.2.1-orig/Plugin/Base.hs	2009-01-18 16:01:14.000000000 +1100
+++ lambdabot-4.2.2.1/Plugin/Base.hs	2010-12-10 13:03:54.287148735 +1100
@@ -12,7 +12,7 @@
 
 import Control.Monad.State  (MonadState(..), when, gets)
 
-import Control.Exception    (Exception(NoMethodError))
+import Control.OldException    (Exception(NoMethodError))
 
 import qualified Data.ByteString.Char8 as P
 import qualified Text.Regex as R
--- lambdabot-4.2.2.1-orig/Plugin/Compose.hs	2009-01-18 16:01:14.000000000 +1100
+++ lambdabot-4.2.2.1/Plugin/Compose.hs	2010-12-10 13:03:54.288171064 +1100
@@ -11,7 +11,7 @@
 
 import Control.Monad.State
 import Control.Arrow (first)
-import Control.Exception   (Exception(NoMethodError))
+import Control.OldException   (Exception(NoMethodError))
 
 $(plugin "Compose")
 
--- lambdabot-4.2.2.1-orig/Plugin/Dict/DictLookup.hs	2009-01-18 16:01:14.000000000 +1100
+++ lambdabot-4.2.2.1/Plugin/Dict/DictLookup.hs	2010-12-10 13:03:54.289173344 +1100
@@ -19,7 +19,7 @@
 
 import Data.List
 import System.IO
-import Control.Exception (handle)
+import Control.OldException (handle)
 import Network
 
 data QueryConfig    = QC { host :: String, port :: Int }
--- lambdabot-4.2.2.1-orig/Plugin/Eval.hs	2009-01-18 16:01:14.000000000 +1100
+++ lambdabot-4.2.2.1/Plugin/Eval.hs	2011-01-05 00:35:12.112690982 +1100
@@ -10,13 +10,13 @@
 import Plugin
 import Lambdabot.Parser
 import Language.Haskell.Exts.Parser
-import Language.Haskell.Exts.Syntax hiding (Module)
+import qualified Language.Haskell.Exts.Syntax as Hs
 import qualified Text.Regex as R
 import System.Directory
 import System.Exit
 import Codec.Binary.UTF8.String (decodeString)
 import qualified Data.ByteString.Char8 as P
-import Control.Exception (try)
+import Control.OldException (try)
 
 $(plugin "Plugs")
 
@@ -50,7 +50,16 @@
 plugs :: String -> IO String
 plugs src = do
             load <- findFile "L.hs"
-            (out,err,_) <- popen binary ["-E", "--timelimit=", "10", "-l", load, "--expression=" ++ src] Nothing
+            -- How it is in darcs
+            -- let args = ["-E", "-XBangPatterns", "-XNoMonomorphismRestriction", "-XViewPatterns", "--noimports", "-l", load, "--expression=" ++ src, "+RTS", "-N2", "-RTS"]
+            -- This is probably what it should be like with -E exchanged for the individual options.
+            -- However it fails at runtime with hint-0.3.3.1 that I patched to compile with ghc 7.0.1
+            -- with mueval-core: UnknownError "flag: '-XNoCPP ... zillions of options ... -XNoNoNewQualifiedOperators' not recognized"
+            -- let args = ["-XForeignFunctionInterface", "-XUnliftedFFITypes", "-XImplicitParams", "-XScopedTypeVariables", "-XUnboxedTuples", "-XTypeSynonymInstances", "-XStandaloneDeriving", "-XDeriveDataTypeable", "-XDeriveFunctor", "-XDeriveFoldable", "-XDeriveTraversable", "-XFlexibleContexts", "-XFlexibleInstances", "-XConstrainedClassMethods", "-XMultiParamTypeClasses", "-XFunctionalDependencies", "-XMagicHash", "-XPolymorphicComponents", "-XExistentialQuantification", "-XUnicodeSyntax", "-XPostfixOperators", "-XPatternGuards", "-XLiberalTypeSynonyms", "-XRankNTypes", "-XTypeOperators", "-XDoRec", "-XParallelListComp", "-XEmptyDataDecls", "-XKindSignatures", "-XGeneralizedNewtypeDeriving", "-XBangPatterns", "-XNoMonomorphismRestriction", "-XViewPatterns", "--noimports", "-l", load, "--expression=" ++ src, "+RTS", "-N2", "-RTS"]
+            -- So hint-0.3.3.1 can not handle any -X options at all, or -E.
+            let args = ["--noimports", "-l", load, "--expression=" ++ src, "+RTS", "-N2", "-RTS"]
+            -- print args
+            (out,err,_) <- popen binary args Nothing
             case (out,err) of
                 ([],[]) -> return "Terminated\n"
                 _       -> do
@@ -67,16 +76,16 @@
 
 define :: String -> IO String
 define src = case parseModule (decodeString src ++ "\n") of -- extra \n so comments are parsed correctly
-    (ParseOk (HsModule _ _ (Just [HsEVar (UnQual (HsIdent "main"))]) [] ds))
+    (ParseOk (Hs.Module _ _ _ _ (Just [Hs.EVar (Hs.UnQual (Hs.Ident "main"))]) [] ds))
         | all okay ds -> comp (Just src)
     (ParseFailed _ e) -> return $ " " ++ e
     _                 -> return "Invalid declaration"
  where
-    okay (HsTypeSig   {}) = True
-    okay (HsFunBind   {}) = True
-    okay (HsPatBind   {}) = True
-    okay (HsInfixDecl {}) = True
-    okay _                = False
+    okay (Hs.TypeSig   {}) = True
+    okay (Hs.FunBind   {}) = True
+    okay (Hs.PatBind   {}) = True
+    okay (Hs.InfixDecl {}) = True
+    okay _                 = False
 
 -- It parses. then add it to a temporary L.hs and typecheck
 comp :: Maybe String -> IO String
@@ -140,6 +149,8 @@
 -- Clean up runplugs' output
 --
 clean_ :: String -> String
+clean_ = id
+{-
 clean_ s|  no_io      `matches'`    s = "No IO allowed\n"
         |  type_sig   `matches'`    s = "Add a type signature\n"
         |  enomem     `matches'`    s = "Tried to use too much memory\n"
@@ -174,6 +185,7 @@
         nomatch    = regex' "Couldn't match[^\n]*\n"
         inaninst   = regex' "^[ \t]*In a.*$"
         enomem     = regex' "^Heap exhausted"
+-}
 
 ------------------------------------------------------------------------
 --
--- lambdabot-4.2.2.1-orig/Plugin/Help.hs	2009-01-18 16:01:14.000000000 +1100
+++ lambdabot-4.2.2.1/Plugin/Help.hs	2010-12-10 13:03:54.290165817 +1100
@@ -3,7 +3,7 @@
 module Plugin.Help (theModule) where
 
 import Plugin
-import Control.Exception    (Exception(..), evaluate)
+import Control.OldException    (Exception(..), evaluate)
 
 $(plugin "Help")
 
--- lambdabot-4.2.2.1-orig/Plugin/IRC.hs	2009-01-18 16:01:14.000000000 +1100
+++ lambdabot-4.2.2.1/Plugin/IRC.hs	2010-12-10 13:03:54.290165817 +1100
@@ -5,7 +5,7 @@
 
 import Control.Concurrent( forkIO, newQSem, waitQSem, threadDelay, signalQSem,
                            newEmptyMVar, putMVar, takeMVar, MVar )
-import Control.Exception
+import Control.OldException
 import IRCBase
 import LMain( received )
 import Message
--- lambdabot-4.2.2.1-orig/Plugin/Quote/Fortune.hs	2009-01-18 16:01:14.000000000 +1100
+++ lambdabot-4.2.2.1/Plugin/Quote/Fortune.hs	2010-12-10 13:03:54.290165817 +1100
@@ -10,7 +10,7 @@
 import Data.List
 import Control.Monad
 import System.Directory
-import qualified Control.Exception as C (catch)
+import qualified Control.OldException as C (catch)
 
 #ifndef mingw32_HOST_OS
 --
--- lambdabot-4.2.2.1-orig/File.hs	2009-01-18 16:01:14.000000000 +1100
+++ lambdabot-4.2.2.1/File.hs	2011-01-04 11:15:57.365397608 +1100
@@ -2,21 +2,26 @@
 
 import Control.Monad
 import System.Directory
+import System.FilePath
 import Paths_lambdabot (getDataFileName)
 
 -- | Constants.
-lambdabot, local, state :: String
-lambdabot = "/.lambdabot/"
-state = lambdabot ++ local
-local = "State/"
+lambdabot, local, state :: FilePath
+lambdabot = ".lambdabot"
+state = lambdabot </> local
+local = "State"
+
+maybeFileExists :: FilePath -> IO (Maybe FilePath)
+maybeFileExists path = 
+    do b <- doesFileExist path
+       return $ if b then Just path else Nothing
 
 -- | For a given file, look locally under State/. That is, suppose one is
 -- running out of a Lambdabot darcs repository in /home/cale/lambdabot. Then
 --
 -- > lookLocally "fact" ~> "/home/cale/lambdabot/State/fact"
 lookLocally :: FilePath -> IO (Maybe String)
-lookLocally f = do b <- doesFileExist (local ++ f)
-                   if b then return $ Just (local ++ f) else return Nothing
+lookLocally file = maybeFileExists $ local </> file
 
 -- | For a given file, look at the home directory. By default, we stash files in
 -- ~/.lambdabot. So, running Lambdabot normally would let us do:
@@ -26,29 +31,24 @@
 -- (Note that for convenience we preserve the "State/foo" address pattern.)
 lookHome :: FilePath -> IO (Maybe String)
 lookHome f = do home <- getHomeDirectory
-                let full = home ++ state ++ f
-                b <- doesFileExist (full)
-                if b then return $ Just full else return Nothing
+                maybeFileExists $ home </> state </> f
 
 -- | Do ~/.lambdabot & ~/.lambdabot/State exist?
 isHome :: IO Bool
 isHome = do home <- getHomeDirectory
-            top <- doesDirectoryExist (home ++ lambdabot)
-            stat <- doesDirectoryExist (home ++ state)
-            return (top && stat)
+            fmap and . mapM (doesDirectoryExist . (home </>)) $ [lambdabot, state]
 
 -- | Create ~/.lambdabot and ~/.lambdabot/State
 mkdirL :: IO ()
 mkdirL = do home <- getHomeDirectory
-            createDirectory (home ++ lambdabot)
-            createDirectory (home ++ state)
+            mapM_ (createDirectory . (home </>)) $ [lambdabot, state]
 
 -- | Ask Cabal for the read-only copy of a file, and copy it into ~/.lambdabot/State.
 cpDataToHome :: FilePath -> IO ()
-cpDataToHome f = do rofile <- getDataFileName ("State/" ++ f)
+cpDataToHome f = do rofile <- getDataFileName (local </> f)
                     home <- getHomeDirectory
                     -- cp /.../lambdabot-4.foo/State/foo ~/.lambdabot/State/foo
-                    copyFile rofile (home ++ state ++ f)
+                    copyFile rofile (home </> state </> f)
 
 -- | Complicated. If a file exists locally, we return that. If a file exists in
 -- ~/lambdabot/State, we return that. If neither the file nor ~/lambdabot/State
@@ -57,7 +57,6 @@
 -- into the conventional functions easily; unfortunately, this removes
 -- error-checking, as an error is now just \"\".
 findFile :: FilePath -> IO String
-
 findFile f = do first <- lookLocally f
                 case first of
                   -- With any luck we can exit quickly
@@ -78,4 +77,7 @@
                                                 g <- lookHome f
                                                 case g of
                                                   Just a -> return a
-                                                  Nothing -> return ""
+                                                  Nothing -> 
+                                                      do home <- getHomeDirectory 
+                                                         fail $ "File.findFile: couldn't find file " 
+                                                                ++ f ++ " in " ++ home </> state
--- lambdabot-4.2.2.1-orig/Modules.hs	2009-01-18 16:01:17.000000000 +1100
+++ lambdabot-4.2.2.1/Modules.hs	2011-01-04 11:15:57.398388910 +1100
@@ -39,7 +39,7 @@
 import qualified Plugin.Pretty
 import qualified Plugin.Quote
 import qualified Plugin.Search
-import qualified Plugin.Seen
+--import qualified Plugin.Seen
 import qualified Plugin.Slap
 import qualified Plugin.Source
 import qualified Plugin.Spell
@@ -53,7 +53,7 @@
 import qualified Plugin.Undo
 import qualified Plugin.Unlambda
 import qualified Plugin.UnMtl
-import qualified Plugin.Url
+--import qualified Plugin.Url
 import qualified Plugin.Version
 import qualified Plugin.Vixen
 import qualified Plugin.Where
@@ -98,7 +98,7 @@
                     , "Pretty"
                     , "Quote"
                     , "Search"
-                    , "Seen"
+                    --, "Seen"
                     , "Slap"
                     , "Source"
                     , "Spell"
@@ -110,7 +110,7 @@
                     , "Undo"
                     , "Unlambda"
                     , "UnMtl"
-                    , "Url"
+                    --, "Url"
                     , "Version"
                     , "Vixen"
                     , "Where"
--- lambdabot-4.2.2.1-orig/Plugin/BF.hs	2009-01-18 16:01:14.000000000 +1100
+++ lambdabot-4.2.2.1/Plugin/BF.hs	2011-01-04 11:15:57.424382336 +1100
@@ -12,11 +12,11 @@
 
 instance Module BFModule () where
     moduleCmds   _     = ["bf"]
-    moduleHelp _ _     = "bf <expr>. Evaluate a bainf*ck expression"
+    moduleHelp _ _     = "bf <expr>. Evaluate a brainf*ck expression"
     process _ _ to _ s = ios80 to (bf s)
 
 binary :: String
-binary = "./bf"
+binary = "bf"
 
 bf :: String -> IO String
 bf src = run binary src scrub
--- lambdabot-4.2.2.1-orig/Plugin/Check.hs	2009-01-18 16:01:14.000000000 +1100
+++ lambdabot-4.2.2.1/Plugin/Check.hs	2011-01-04 11:15:57.427382599 +1100
@@ -30,7 +30,7 @@
         Left  e -> return e
         Right _ -> do
             l <- findFile "L.hs"
-            (out,err,_) <- popen binary ["--loadfile=", l, "-E", "-e", "myquickcheck $ " ++ src] Nothing
+            (out,err,_) <- popen binary ["--loadfile=", l, "-XExtendedDefaultRules", "-e", "myquickcheck $ " ++ src] Nothing
             case (out,err) of
                 ([],[]) -> return "Terminated\n"
                 _       -> do
--- lambdabot-4.2.2.1-orig/Plugin/Dummy.hs	2009-01-18 16:01:14.000000000 +1100
+++ lambdabot-4.2.2.1/Plugin/Dummy.hs	2011-01-04 11:15:57.447383278 +1100
@@ -53,7 +53,7 @@
   contextual _ _ _ _                 = return []
 
 pastebinMsg :: String
-pastebinMsg = "Haskell pastebin: http://hpaste.org/new"
+pastebinMsg = "Haskell pastebin: http://hpaste.org/"
 
 dummylst :: [(String, String -> String)]
 dummylst =
@@ -95,7 +95,7 @@
 
 lookupHackage :: String -> String
 lookupHackage "" = "http://hackage.haskell.org"
-lookupHackage xs = "http://hackage.haskell.org/cgi-bin/hackage-scripts/package/" ++ xs
+lookupHackage xs = "http://hackage.haskell.org/package/" ++ xs
 
 googlePrefix :: String
 googlePrefix = "http://letmegooglethatforyou.com"
--- lambdabot-4.2.2.1-orig/Plugin/Dummy/DocAssocs.hs	2009-01-18 16:01:14.000000000 +1100
+++ lambdabot-4.2.2.1/Plugin/Dummy/DocAssocs.hs	2011-01-04 11:15:57.447383278 +1100
@@ -40,6 +40,8 @@
 x11      = P.pack "3"
 opengl :: P.ByteString
 opengl   = P.pack "OpenGL"
+containers :: P.ByteString
+containers = P.pack "containers"
 
 docAssocs :: M.Map P.ByteString P.ByteString
 docAssocs = {-# SCC "Dummy.DocAssocs" #-} M.fromList [
@@ -94,7 +96,7 @@
   (P.pack "Data.Generics.Schemes", base),
   (P.pack "Data.Generics.Text", base),
   (P.pack "Data.Generics.Twins", base),
-  (P.pack "Data.Graph", base),
+  (P.pack "Data.Graph", containers),
   (P.pack "Data.Graph.Inductive", fgl),
   (P.pack "Data.Graph.Inductive.Basic", fgl),
   (P.pack "Data.Graph.Inductive.Example", fgl),
@@ -126,11 +128,11 @@
   (P.pack "Data.HashTable", base),
   (P.pack "Data.IORef", base),
   (P.pack "Data.Int", base),
-  (P.pack "Data.IntMap", base),
-  (P.pack "Data.IntSet", base),
+  (P.pack "Data.IntMap", containers),
+  (P.pack "Data.IntSet", containers),
   (P.pack "Data.Ix", base),
   (P.pack "Data.List", base),
-  (P.pack "Data.Map", base),
+  (P.pack "Data.Map", containers),
   (P.pack "Data.Maybe", base),
   (P.pack "Data.Monoid", base),
   (P.pack "Data.PackedString", base),
@@ -139,8 +141,9 @@
   (P.pack "Data.STRef", base),
   (P.pack "Data.STRef.Lazy", base),
   (P.pack "Data.STRef.Strict", base),
-  (P.pack "Data.Set", base),
-  (P.pack "Data.Tree", base),
+  (P.pack "Data.Sequence", containers),
+  (P.pack "Data.Set", containers),
+  (P.pack "Data.Tree", containers),
   (P.pack "Data.Tuple", base),
   (P.pack "Data.Typeable", base),
   (P.pack "Data.Unique", base),
--- lambdabot-4.2.2.1-orig/Plugin/Karma.hs	2009-01-18 16:01:14.000000000 +1100
+++ lambdabot-4.2.2.1/Plugin/Karma.hs	2011-01-04 11:15:57.473383756 +1100
@@ -56,7 +56,7 @@
         okay x      = not (elem x badNicks || any (`isPrefixOf` x) badPrefixes)
         -- Special cases.  Ignore the null nick.  C must also be ignored
         -- because C++ and C-- are languages.
-        badNicks    = ["", "C", "c"]
+        badNicks    = ["", "C", "c", "notepad"]
         -- More special cases, to ignore Perl code.
         badPrefixes = ["$", "@", "%"]
 
--- lambdabot-4.2.2.1-orig/Plugin/Pl.hs	2009-01-18 16:01:14.000000000 +1100
+++ lambdabot-4.2.2.1/Plugin/Pl.hs	2011-01-04 11:15:57.482383419 +1100
@@ -22,7 +22,7 @@
 import Message( Nick )
 
 import Control.Concurrent.Chan    (Chan, newChan, isEmptyChan, readChan, writeList2Chan)
-
+import Control.Exception (unblock)
 -- firstTimeout is the timeout when the expression is simplified for the first
 -- time. After each unsuccessful attempt, this number is doubled until it hits
 -- maxTimeout.
@@ -80,7 +80,10 @@
 optimizeIO :: Int -> Expr -> IO (Expr, Bool)
 optimizeIO to e = do
   chan <- newChan
-  result <- timeout to $ writeList2Chan chan $ optimize e
+  -- We need "unblock" here because "timeout" will terminate the thread
+  -- with an async exception and the current thread is in blocked
+  -- mode for reasons that still aren't clear to me.
+  result <- timeout to $ unblock (writeList2Chan chan $ optimize e)
   e' <- getChanLast chan e
   return $ case result of
     Nothing -> (e', False)
--- lambdabot-4.2.2.1-orig/Plugin/Scheck.hs	2009-01-18 16:01:14.000000000 +1100
+++ lambdabot-4.2.2.1/Plugin/Scheck.hs	2011-01-04 11:15:57.486382346 +1100
@@ -27,7 +27,7 @@
         Left e  -> return e
         Right _ -> do
             file <- findFile "L.hs"
-            (out,err,_) <- popen binary ["--loadfile=", file, "-E", "-e", "mysmallcheck " ++ src ++ ""] Nothing
+            (out,err,_) <- popen binary ["--loadfile=", file, "-XExtendedDefaultRules", "-e", "mysmallcheck " ++ src ++ ""] Nothing
             let o = munge out
                 e = munge err
             return $ case () of {_
--- lambdabot-4.2.2.1-orig/Plugin/Search.hs	2009-01-18 16:01:14.000000000 +1100
+++ lambdabot-4.2.2.1/Plugin/Search.hs	2011-01-04 11:15:57.487382464 +1100
@@ -1,4 +1,4 @@
-{-# LANGUAGE TemplateHaskell, MultiParamTypeClasses #-}
+{-# LANGUAGE TemplateHaskell, MultiParamTypeClasses, ViewPatterns #-}
 -- | Search various things, Wikipedia and google for now.
 --
 -- (c) 2005 Samuel Bronson
@@ -9,77 +9,92 @@
 module Plugin.Search (theModule) where
 
 import Plugin
-import Control.Monad            (mplus)
-import qualified Text.Regex as R
+import Network.HTTP
+import Text.HTML.TagSoup
+import Text.HTML.TagSoup.Match (anyAttr, tagOpen)
+import Data.Maybe (listToMaybe)
 
 $(plugin "Search")
 
-engines :: [(String, (String, String))]
+engines :: [(String, (URI, String -> String, [Header]))]
 engines =
-   [("google"
-   ,("http://www.google.com/search?hl=en&q=","&btnI=I%27m+Feeling+Lucky")),
+   [("google", (googleUri, (\s -> "?hl=en&q="++s++"&btnI=I'm+Feeling+Lucky"), googleHeaders)),
+    -- ("wikipedia", (wikipediaUri, ("?search="++), [])), -- this has changed and Wikipedia requires a User-Agent string
+    ("gsite", (googleUri, (\s -> "?hl=en&q=site%3A"++s++"&btnI=I'm+Feeling+Lucky"), googleHeaders)),
+    ("gwiki", (googleUri, (\s -> "?hl=en&q=site%3Ahaskell.org/haskellwiki+" ++s++"&btnI=I'm+Feeling+Lucky"), googleHeaders))
+   ]
 
-    ("wikipedia"
-   ,("http://en.wikipedia.org/wiki/Special:Search?search=", "")),
+googleHeaders :: [Header]
+googleHeaders = [mkHeader HdrReferer "http://www.google.com/"]
 
-    ("gsite"
-   ,("http://www.google.com/search?hl=en&q=site%3A", "&btnI=I%27m+Feeling+Lucky"))
-   ]
+normalizeOptions :: NormalizeRequestOptions a
+normalizeOptions = defaultNormalizeRequestOptions {
+    normDoClose = True,
+    normForProxy = isJust (proxy config),
+    normUserAgent = Nothing } -- there is a default user agent, perhaps we want it?
+
+makeUri :: String -> String -> URI
+makeUri regName path = nullURI {
+    uriScheme = "http:",
+    uriAuthority = Just (URIAuth { uriUserInfo = "", uriRegName = regName, uriPort = "" }),
+    uriPath = path }
+
+googleUri :: URI
+googleUri = makeUri "www.google.com" "/search"
+-- wikipediaUri = makeUri "en.wikipedia.org" "/wiki/Special:Search"
 
 instance Module SearchModule () where
     moduleHelp _ s      = case s of
          "google"    -> "google <expr>. Search google and show url of first hit"
-         "wikipedia" -> "wikipedia <expr>. Search wikipedia and show url of first hit"
+         -- "wikipedia" -> "wikipedia <expr>. Search wikipedia and show url of first hit"
          "gsite"     -> "gsite <site> <expr>. Search <site> for <expr> using google"
-         "gwiki"     -> "wiki <expr>. Search (new) haskell.org wiki for <expr> using google."
-    moduleCmds      _   = "gwiki" : map fst engines
-    process_ _ "gwiki" e = lift $ ((. dropSpace) . searchCmd) "gsite" ("haskell.org/haskellwiki" ++ e)
-    process_ _ s       e = lift $ ((. dropSpace) . searchCmd) s e
+         "gwiki"     -> "gwiki <expr>. Search (new) haskell.org wiki for <expr> using google."
+    moduleCmds _ = map fst engines
+    process_ _ s e = lift $ searchCmd s (dropSpace e)
 
 ------------------------------------------------------------------------
 
 searchCmd :: String -> String -> LB [String]
-searchCmd _ []        = return ["Empty search."]
-searchCmd engine rest = do
-    headers <- io $ queryit "HEAD" engine rest
-    body    <- io $ queryit "GET" engine rest
-    case getHeader "Location" headers `mplus` extractConversion body of
-      Just url -> do
-        title <- io $ runWebReq (urlPageTitle url) (proxy config)
-        return $ maybe [url] (\t -> [url, t]) title
-      Nothing  -> return ["No Result Found."]
-
-queryUrl :: String -> String -> String
-queryUrl engine q = prefix ++ urlEncode q ++ suffix
-    where
-    (prefix, suffix) = fromMaybe (error "search: invalid command")
-                                 (lookup engine engines)
-
-queryit :: String -> String -> String -> IO [String]
-queryit meth engine q = readPage (proxy config) uri request ""
-    where url = queryUrl engine q
-          Just uri = parseURI url
-          abs_path = uriPath uri ++ uriQuery uri ++ uriFragment uri
-          request  = case proxy config of
-                        Nothing -> [meth ++ " " ++ abs_path ++ " HTTP/1.0", ""]
-                        _       -> [meth ++ " " ++ url ++ " HTTP/1.0", ""]
-
-extractConversion :: [String] -> Maybe String
-extractConversion [] = error "conv: No response, something weird is up."
-extractConversion ls = (getConv $ last ls) >>= return . pipeline replaceFuncs
-    where
-        regex1 = regex' "<font size=\\+1><b>"
-        regex2 = regex' "</b>"
-
-        getConv a = do
-            (_,_,s,_)  <- R.matchRegexAll regex1 a
-            (s',_,_,_) <- R.matchRegexAll regex2 s
-            return s'
-
-        searchAndReplace new re = \s -> R.subRegex (regex' re) s new
-        replaceFuncs = zipWith searchAndReplace
-                            [    "^",       "",      "x",                      ","]
-                            ["<sup>", "</sup>", "&#215;", "<font size=-2> </font>"]
-
-        pipeline [] a = a
-        pipeline (f:fs) a = pipeline fs $ f a
+searchCmd _          []   = return ["Empty search."]
+searchCmd engineName (Network.HTTP.urlEncode -> query)
+    | engineName == "google" = -- for Google we do both to get conversions, e.g. for '3 lbs in kg'
+        doHTTP request $ \response -> 
+        case response of
+            Response { rspCode = (3,0,2), rspHeaders = (lookupHeader HdrLocation -> Just url) } ->
+                doGoogle >>=  handleUrl url
+            _ -> fmap (\extra -> if null extra then ["No Result Found."] else extra) doGoogle
+    | otherwise = 
+        doHTTP request $ \response -> 
+        case response of
+            Response { rspCode = (3,0,2), rspHeaders = (lookupHeader HdrLocation -> Just url) } ->
+                handleUrl url []
+            _ -> return ["No Result Found."]
+  where handleUrl url extra = do
+            title <- io $ runWebReq (urlPageTitle url) (proxy config)
+            return $ extra ++ maybe [url] (\t -> [url, t]) title
+        Just (uri, makeQuery, headers) = lookup engineName engines
+        request = normalizeRequest normalizeOptions $ Request {
+            rqURI = uri { uriQuery = makeQuery query },
+            rqMethod = HEAD,
+            rqHeaders = headers,
+            rqBody = "" }
+        doGoogle = 
+            doHTTP (request { rqMethod = GET, rqURI = uri { uriQuery = "?hl=en&q=" ++ query } }) $ \response ->
+                case response of
+                    Response { rspCode = (2,_,_), rspBody = (extractConversion -> Just result) } ->
+                        return [result]
+                    _ -> return []
+
+doHTTP :: HStream a => Request a -> (Response a -> LB [String]) -> LB [String]
+doHTTP request handler = do
+    result <- io $ simpleHTTP request
+    case result of
+        Left connError -> return ["Connection error: "++show connError]
+        Right response -> handler response
+
+-- This is clearly fragile.
+extractConversion :: String -> Maybe String
+extractConversion (parseTags -> tags) = listToMaybe [txt |
+    section <- sections (tagOpen ("h2"==) (anyAttr (\(name, value) -> name == "class" && value == "r"))) tags,
+    txt <- [dropSpace $ drop 1 $ dropWhile (/= '=') t | TagText t <- section],
+    not (null txt)]
--- lambdabot-4.2.2.1-orig/Plugin/Type.hs	2009-01-18 16:01:15.000000000 +1100
+++ lambdabot-4.2.2.1/Plugin/Type.hs	2011-01-04 11:15:57.502466304 +1100
@@ -123,7 +123,7 @@
                        (readFile importHeader)
        l <- findFile "L.hs"
        let context = ":load "++l++"\n" ++ concatMap ((":m + " ++) . (++"\n")) imports
-       (output, errors, _) <- popen (ghci config) ["-v0","-fglasgow-exts","-fno-th","-iState","-iscripts","-XNoMonomorphismRestriction"]
+       (output, errors, _) <- popen (ghci config) ["-v0","-fglasgow-exts","-XNoTemplateHaskell","-iState","-iscripts","-XNoMonomorphismRestriction"]
                                        (Just (context ++ command cmd (stripComments expr)))
        let ls = extract_signatures output
        return $ case ls of
--- lambdabot-4.2.2.1-orig/Plugin/Undo.hs	2009-01-18 16:01:15.000000000 +1100
+++ lambdabot-4.2.2.1/Plugin/Undo.hs	2011-01-04 11:15:57.503543429 +1100
@@ -15,13 +15,13 @@
 $(plugin "Undo")
 
 instance Module UndoModule () where
-    moduleCmds   _ = ["undo", "redo"]
+    moduleCmds   _ = ["undo", "do"]
     moduleHelp _ "undo" = "undo <expr>\nTranslate do notation to Monad operators."
-    moduleHelp _ "redo" = "redo <expr>\nTranslate Monad operators to do notation."
+    moduleHelp _ "do" = "do <expr>\nTranslate Monad operators to do notation."
     process_ _ cmd args = ios $ return $ transform f args
      where f = case cmd of
                 "undo" -> undo
-                "redo" -> redo
+                "do" -> do'
                 _      -> error "unknown command"
 
 findVar :: Data a => a -> String
@@ -92,29 +92,29 @@
 pvar :: String -> HsPat
 pvar = HsPVar . HsIdent
 
-redo :: String -> HsExp -> HsExp
-redo _ (HsLet ds (HsDo s)) = HsDo (HsLetStmt ds : s)
-redo v e@(HsInfixApp l (HsQVarOp (UnQual (HsSymbol op))) r) =
-    case op of
-        ">>=" ->
-            case r of
-                (HsLambda loc [p] (HsDo stms)) -> HsDo (HsGenerator loc p l : stms)
-                (HsLambda loc [HsPVar v1] (HsCase (HsVar (UnQual v2))
-                                           [ HsAlt _ p (HsUnGuardedAlt s) []
-                                           , HsAlt _ HsPWildCard (HsUnGuardedAlt (HsApp (HsVar (UnQual (HsIdent "fail"))) _)) []
-                                           ]))
-                          | v1 == v2           -> case s of
-                                                      HsDo stms -> HsDo (HsGenerator loc p l : stms)
-                                                      _         -> HsDo [HsGenerator loc p l, HsQualifier s]
-                (HsLambda loc [p] s)           -> HsDo [HsGenerator loc p l, HsQualifier s]
-                _ -> HsDo [ HsGenerator undefined (pvar v) l
-                          , HsQualifier . app r $ var v]
-        ">>" ->
-            case r of
-                (HsDo stms) -> HsDo (HsQualifier l : stms)
-                _           -> HsDo [HsQualifier l, HsQualifier r]
-        _    -> e
-redo _ x = x
+do' :: String -> HsExp -> HsExp
+do' _ (HsLet ds (HsDo s)) = HsDo (HsLetStmt ds : s)
+do' v e@(HsInfixApp l (HsQVarOp (UnQual (HsSymbol op))) r) =
+     case op of
+         ">>=" ->
+             case r of
+                 (HsLambda loc [p] (HsDo stms)) -> HsDo (HsGenerator loc p l : stms)
+                 (HsLambda loc [HsPVar v1] (HsCase (HsVar (UnQual v2))
+                                            [ HsAlt _ p (HsUnGuardedAlt s) []
+                                            , HsAlt _ HsPWildCard (HsUnGuardedAlt (HsApp (HsVar (UnQual (HsIdent "fail"))) _)) []
+                                            ]))
+                           | v1 == v2           -> case s of
+                                                       HsDo stms -> HsDo (HsGenerator loc p l : stms)
+                                                       _         -> HsDo [HsGenerator loc p l, HsQualifier s]
+                 (HsLambda loc [p] s)           -> HsDo [HsGenerator loc p l, HsQualifier s]
+                 _ -> HsDo [ HsGenerator undefined (pvar v) l
+                           , HsQualifier . app r $ var v]
+         ">>" ->
+             case r of
+                 (HsDo stms) -> HsDo (HsQualifier l : stms)
+                 _           -> HsDo [HsQualifier l, HsQualifier r]
+         _    -> e
+do' _ x = x
 
 -- | 'app' is a smart constructor that inserts parens when the first argument
 -- is an infix application.
